#include "AntX.h"

//////////////////////////////////////////////////////////////////////////////////
//					CAntX - Rahmenklasse fr das Spiel							//
//////////////////////////////////////////////////////////////////////////////////
CAntX::CAntX(short screen_breite, short screen_hoehe, short feld_breite, short feld_hoehe, short schwfl)
{
	// Zufallszahlengenerator starten
	srand((unsigned)time( NULL ));

	spfeld = new CSpielfeld(screen_breite,screen_hoehe,feld_breite,feld_hoehe);
	player = new CPlayer(spfeld);

	anz_gegner=0;
	gegner=0;

	schweifl=schwfl;
	level=1;
	versuche=0;

	// damit der player wei welcher Level gerad ist -> wichtig fr die Punktberechnung
	player->level=&level;

	level_init();
}

CAntX::~CAntX()
{
	if(player) delete player;

	if(gegner)
	{
		for (short i=anz_gegner;i>0;i--)
			delete gegner[i-1];
		 delete [] gegner;
	}

	// Spielfeld wieder freigeben
	if(spfeld) delete spfeld;
}

void CAntX::level_init()
{
	int i;

	// noch vorhande Gegner lschen
	if(gegner)
	{
		for (i=anz_gegner;i>0;i--)
			delete gegner[i-1];
		 delete [] gegner;
	}

	// spielfeld bereinigen
	spfeld->clear();

	// player auf startposition setzen
	player->auf_start();

	// Gegner erzeugen
	anz_gegner=level+1;
	gegner= new CGegner*[anz_gegner];
	for(i=0;i<anz_gegner;i++)
		gegner[i]= new CGegner(spfeld,schweifl);

	status=SPIELEN;
}

void CAntX::press(SDLKey taste)
{
	switch(status)
	{
	case SPIELEN:
		switch (taste)
		{
		case SDLK_KP8:
		case SDLK_UP: player->bewegen(8);break;
		case SDLK_KP2:
		case SDLK_DOWN: player->bewegen(2);break;
		case SDLK_KP6:
		case SDLK_RIGHT: player->bewegen(6);break;
		case SDLK_KP4:
		case SDLK_LEFT: player->bewegen(4);break;
		case SDLK_KP0:
		case SDLK_RCTRL: player->bewegen(0);break;
		}
		break;

	case VERLOREN:
		versuche++;
		level_init();
		break;
	
	case LEVEL_WECHSEL:
		level++;
		level_init();

		break;
	}
}

void CAntX::tick()
{
	int i;
	static bool neu_zeichnen=false;
	static Uint32 geschw_gegner=(GESCHW/4)*3;
	static Uint32 starttime_spieler=SDL_GetTicks();
	static Uint32 starttime_gegner=starttime_spieler;

	switch(status)
	{
	case SPIELEN:
		// kontrolle ob ein Levelwechsel ntig ist
		if(player->mein_prozent>75)
		{
			SDL_WM_SetCaption("L E V E L - W E C H S E L !   ---  weiter mit Tatse","");
			spfeld->zeichnen();
			player->gesamtpunkte+=player->levelpunkte;
			status=LEVEL_WECHSEL;
			break;
		}

		if((SDL_GetTicks()-starttime_spieler)>=GESCHW)
		{
			spfeld->lock();
			player->tick();
			spfeld->unlock();
			neu_zeichnen=true;
			starttime_spieler=SDL_GetTicks();
		}
		if((SDL_GetTicks()-starttime_gegner)>=geschw_gegner)
		{
			spfeld->lock();
			for(i=0;i<anz_gegner;i++)
				gegner[i]->tick();
			spfeld->unlock();
			neu_zeichnen=true;
			starttime_gegner=SDL_GetTicks();
		}

		// Kontrolle ob der Spieler verloren oder gewonnen hat
		if(neu_zeichnen)
		{
			bool test=false;
			test|=player->verloren;
			for(i=0;i<anz_gegner;i++)
				test|=gegner[i]->playertreffer;

			if(test)
			{
				SDL_WM_SetCaption("V E R L O R E N !   ---  weiter mit Tatse","");
				spfeld->zeichnen();
				status=VERLOREN;
				break;
			}
		}
		
		// muss das feld neu gezeichnet werden?
		if(neu_zeichnen)
		{
			spfeld->zeichnen();
			char caption[100];
			sprintf(caption,"AntX: %d%%  --- Punkte: %d --- Versuche: %d",
					player->mein_prozent, player->gesamtpunkte+player->levelpunkte, versuche);
			SDL_WM_SetCaption(caption,caption);
			neu_zeichnen=false;
		}

		break;	
	}

}


