#include "CGegner.h"

/********************************************************************************************\
** CGegner - Funktionen zum Steuern der Gegner ***********************************************
\********************************************************************************************/
CSpielfeld *CGegner::spfeld=0;
CGegner::CGegner(CSpielfeld *spfeld,short schweiflaenge)
{
	short i;

	this->spfeld=spfeld;
	this->schweifl=schweiflaenge;

	schweif = new strSchweif[schweifl];

	// Startposition
	schweif[0].pos_x=1+rand()%(spfeld->breite-1);
	schweif[0].pos_y=1+rand()%(spfeld->hoehe-1);

	for(i=1;i<schweifl;i++)
		schweif[i]=schweif[0];

	// bewgungsrichtung
	dx=-1+rand()%3;
	dy=-1+rand()%3;

	playertreffer=false;

	// fr die zufllige richtungsnderung
	intervall_richtung=Uint32(rand()%10000);
	time=SDL_GetTicks();
}

CGegner::~CGegner()
{
	delete [] schweif;
}

void CGegner::tick()
{
	short i;

	// zufllig eine neue bewegunsrichtung setzen
	if((SDL_GetTicks()-time)>=intervall_richtung)
	{
		dx=-2+rand()%5;
		dy=-2+rand()%5;
		if((dx==0)&&(dy==0)) intervall_richtung=1+rand()%1000;
		intervall_richtung=1+rand()%10000;
		time=SDL_GetTicks();
	}

	// er soll nicht allzulange stillstehen
	if((dx==0)&&(dy==0)) intervall_richtung=rand()%1000;

	// schweif nachrcken
	for(i=schweifl-1;i>0;i--)
		schweif[i]=schweif[i-1];

	// Kollision abfragen und bewegen
	if (!kollision())
	{
		short new_x = schweif[0].pos_x+dx;
		short new_y = schweif[0].pos_y+dy;
		// berprfen wie schnell er sich bewegt
		schweif[1]=schweif[0];
		schweif[0].pos_x=new_x;
		schweif[0].pos_y=new_y;
	}
	else
	{
		dx=-2+rand()%5;
		dy=-2+rand()%5;
	}
		
	// Schweif zeichnen (erstes in der Farbe, letztes in der Hintergrundfarbe)
	spfeld->putpixel(schweif[0].pos_x, schweif[0].pos_y, spfeld->farben.gegner);
	spfeld->putpixel(schweif[schweifl-1].pos_x, schweif[schweifl-1].pos_y, spfeld->farben.hint);

}

bool CGegner::kollision()
{
	short x=schweif[0].pos_x+dx;
	short y=schweif[0].pos_y+dy;

	// innerhalb des feldes
	if(x<0||x>spfeld->breite-1||y<0||y>spfeld->hoehe-1)
		return true;

	// wenn er sich schneller als ein feld bewegt
	// die zwischenfelder mit prfen
	if((dx%2==0)||(dy%2==0))
	{
		short xz=schweif[0].pos_x+(dx/2);
		short yz=schweif[0].pos_y+(dy/2);

		if(spfeld->getpixel(xz,yz)==spfeld->farben.player_old)
			return true;
		else if(spfeld->getpixel(xz,yz)==spfeld->farben.player_new)
		{
			if(spfeld->player_action) playertreffer=true;
			return true;
		}

	}

	// Koolision mit Spielerfeld
	if(spfeld->getpixel(x,y)==spfeld->farben.player_old)
		return true;
	else if(spfeld->getpixel(x,y)==spfeld->farben.player_new)
	{
		if(spfeld->player_action) playertreffer=true;
		return true;
	}

	// wenn keine Kollision
	return false;
}
