#include "CPlayer.h"

/********************************************************************************************\
** CPlayer - Funktionen zum Steuern des Spielers *********************************************
\********************************************************************************************/

CPlayer::CPlayer(CSpielfeld* spfeld,short x, short y)
{
    int i;
	// Posotion des Spielers
	pos_x=x;
	pos_y=y;

	// Bewegungsrichtung
	dx=0;
	dy=0;

	level=0;

	// action ist true wenn der Spieler neus Feld betritt
	spfeld->player_action=false;

	// pointer zum Spielfeld
	this->spfeld = spfeld;

	// "meins" erzeugen
	schon_getestet=new bool*[spfeld->breite];
	for(i=0;i<spfeld->breite;i++)
		schon_getestet[i]=new bool[spfeld->hoehe];

	for(i=0;i<spfeld->breite;i++)
		for(short j=0;j<spfeld->hoehe;j++)
			schon_getestet[i][j]=spfeld->mein_feld[i][j];

	// was alles mir gehrt
	mein_prozent=0;

	// punkte
	gesamtpunkte=levelpunkte=0;

	verloren=false;
}

CPlayer::~CPlayer()
{
	// Speicher von "meins" wieder freigeben
	for(int i=0;i<spfeld->breite;i++)
		delete[] schon_getestet[i];

		delete[] schon_getestet;
}

void CPlayer::auf_start()
{
	// pos und bew zurcksetzen
	pos_x=spfeld->breite/2;
	pos_y=0;
	dx=dy=0;

	// verloren zurcksetzen
	verloren=false;

	// prozente zurcksetzen
	mein_prozent=0;

	// levelpunkte zurcksetzen
	levelpunkte=0;

	// spieler zeichnen
	spfeld->putpixel(pos_x,pos_y,spfeld->farben.player_new);
}


void CPlayer::tick()
{
	// Nchster Punkt Mglich
	short new_x=pos_x+dx;
	short new_y=pos_y+dy;

	// berprfen ob er sich berhaupt bewegt
	if((dx==0)&&(dy==0)) return;

	// Ist er auch wirklich im Spielfeld
	if(new_x<0||new_x>spfeld->breite-1||new_y<0||new_y>spfeld->hoehe-1)
	{
		bewegen(0);
		return;
	}

	// Kollisio abfragen und bewegen
	if(spfeld->getpixel(new_x,new_y)==spfeld->farben.hint)
	{
		if (spfeld->player_action==false)
		{
			spfeld->putpixel(pos_x, pos_y,spfeld->farben.player_old);
			spfeld->player_action=true;
		}
		pos_x=new_x;
		pos_y=new_y;
		spfeld->putpixel(pos_x, pos_y,spfeld->farben.player_new);
	}
	else if(spfeld->getpixel(new_x,new_y)==spfeld->farben.player_old)
	{
		if (spfeld->player_action)
		{
			spfeld->player_action=false;
			pos_x=new_x;
			pos_y=new_y;
			spfeld->putpixel(pos_x, pos_y,spfeld->farben.player_new);
			fuellen();
			bewegen(0);
		}
		else
		{
			spfeld->putpixel(pos_x, pos_y,spfeld->farben.player_old);
			pos_x=new_x;
			pos_y=new_y;
			spfeld->putpixel(pos_x, pos_y,spfeld->farben.player_new);
		}
	}
	else
	{
		verloren=true;
	}

}

void CPlayer::bewegen(short richtung)
{
	// abfrage, damit man nicht ausversehen in die
	// entgegengesetze richtung drckt
	if((richtung==8)&&(dy==1))dy=0;
	else if((richtung==2)&&(dy==-1))dy=0;
	else if((richtung==6)&&(dx==-1))dx=0;
	else if((richtung==4)&&(dx==1))dx=0;
	else
	{
		// richtung ndern
		switch (richtung)
		{
		case 8:dx=0;dy=-1;break;
		case 2:dx=0;dy=1;break;
		case 6:dx=1;dy=0;break;
		case 4:dx=-1;dy=0;break;
		case 0:dx=0;dy=0;break;
		}
	}
}



void CPlayer::fuellen()
{
	short i,j;
	short alt_mein_prozent=mein_prozent;

	// alles neue mit der spielfarbe angleichen
	for(i=0;i<spfeld->breite;i++)
		for(j=0;j<spfeld->hoehe;j++)
			if(spfeld->mein_feld[i][j]==false)
				if(spfeld->getpixel(i,j)==spfeld->farben.player_new)
				{
					spfeld->putpixel(i,j,spfeld->farben.player_old);
					spfeld->mein_feld[i][j]=true;
				}

	// in den vier felder um die jetztige position herum testen und fllen
	if(pos_y<spfeld->hoehe-1)
	{
		if(pos_x<spfeld->breite-1)
		{
			feldtest=true;
			schon_getestet_angleichen();
			fuellen_moegl(pos_x+1,pos_y+1);
			if (feldtest) bereich_fill(pos_x+1,pos_y+1);
		}
		if(pos_x>0)
		{
			feldtest=true;
			schon_getestet_angleichen();
			fuellen_moegl(pos_x-1,pos_y+1);
			if (feldtest) bereich_fill(pos_x-1,pos_y+1);
		}
	}

	if(pos_y>0)
	{
		if(pos_x<spfeld->breite-1)
		{
			feldtest=true;
			schon_getestet_angleichen();
			fuellen_moegl(pos_x+1,pos_y-1);
			if (feldtest) bereich_fill(pos_x+1,pos_y-1);
		}
		if(pos_x>0)
		{
			feldtest=true;
			schon_getestet_angleichen();
			fuellen_moegl(pos_x-1,pos_y-1);
			if (feldtest) bereich_fill(pos_x-1,pos_y-1);
		}
	}


	// bereich testen
	int meinstest=0;
	for(i=1;i<spfeld->breite-1;i++)
		for(j=1;j<spfeld->hoehe-1;j++)
			if(spfeld->getpixel(i,j)==spfeld->farben.player_old) meinstest++;

	static int alles=(spfeld->breite-2 )*(spfeld->hoehe-2);
	mein_prozent=(100*meinstest)/alles;

	// punkte berechnen
	int bonusfaktor=(mein_prozent - alt_mein_prozent)/FAKTOR;
	levelpunkte+= (*level)*(mein_prozent - alt_mein_prozent)*((bonusfaktor>1)?bonusfaktor:1);
	
	
		
}

void CPlayer::fuellen_moegl(short x, short y)
{
	if((schon_getestet[x][y]==false)&&(feldtest==true))
	{
		schon_getestet[x][y]=true;
		if(spfeld->getpixel(x,y)==spfeld->farben.hint)
		{
			if((x+1)<spfeld->breite) fuellen_moegl(x+1,y);
			if((x-1)>=0) fuellen_moegl(x-1,y);
			if((y+1)<spfeld->hoehe) fuellen_moegl(x,y+1);
			if((y-1)>=0) fuellen_moegl(x,y-1);
		}
		else 
		{
			feldtest=false;
		}
	}
}

void CPlayer::bereich_fill(short x, short y)
{
	if(spfeld->mein_feld[x][y]==false)
	{
		// Punkt setzen
		spfeld->putpixel(x,y,spfeld->farben.player_old);
		spfeld->mein_feld[x][y]=true;

		// weiter machen
		if((x+1)<spfeld->breite) bereich_fill(x+1,y);
		if((x-1)>=0) bereich_fill(x-1,y);
		if((y+1)<spfeld->hoehe) bereich_fill(x,y+1);
		if((y-1)>=0) bereich_fill(x,y-1);
	}
}

void CPlayer::schon_getestet_angleichen()
{
	short i,j;
	for(i=0;i<spfeld->breite;i++)
		for(j=0;j<spfeld->hoehe;j++)
			schon_getestet[i][j]=spfeld->mein_feld[i][j];

}
