// IniFile.h: Schnittstelle fr die Klasse CIniFile.
//
//////////////////////////////////////////////////////////////////////

#if !defined(HEADER_INIFILE_KLASSE)
#define HEADER_INIFILE_KLASSE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Definitionen
#define INI_LEN_FILENAME	30
#define INI_LEN_WERTNAME	20
#define INI_LEN_WERT		50
#define INI_LEN_KAYNAME		INI_LEN_WERTNAME
// werden fr das Einlesen von daten bentigt
#define INI_LEN_PUFFER_NAME	((INI_LEN_KAYNAME>INI_LEN_WERTNAME)?INI_LEN_KAYNAME:INI_LEN_WERTNAME)
#define INI_INPUT_PUFFER	100

class CIniFile  
{
public:
	// Struktur eines Wertes
	typedef struct tstrWert
	{
		char name[INI_LEN_WERTNAME+1];
		char wert[INI_LEN_WERT+1];
		tstrWert* next_wert;
	} strWert;

	// Struktur eines Schlssels
	typedef struct tstrKay
	{
		char name[INI_LEN_KAYNAME+1];
		strWert* werte;
		tstrKay* next_kay;
	} strKay;
	
	// Konstr. und Destr.
	CIniFile();
	CIniFile(char* filename);
	virtual ~CIniFile();

	// Funktion zum Scheichern der Ini-Datei
	void save(char* newfilename=0);

	// Funktionen fr Neue_Schlssel und Neue_Werte
	bool new_kay(char* kayname);
	bool new_wert(char* kayname, char* wertname, char* wert);	// kayname=0 -> a_kay
	bool new_wert(char* kayname, char* wertname, int wert);		// kayname=0 -> a_kay
	
	// Funktion zum bearbeiten der Werte
	bool set_wert(char* kayname, char* wertname, char* wert);

	// Funktionen zum Auslesen der Werte
	char* get_wert_c(char* kayname, char* wertname);
	int get_wert_i(char* kayname, char* wertname);
	double get_wert_f(char* kayname, char* wertname);

	// Funktion zum Anzeigen des Baums
	void show();
	
	// Funktion zum Lschen der gesamten liste
	void del_all();

	// Variable die angiebt, ob die Ini-Datei erfolgrich geffnet/eingelesen wurde
	bool ready;

private:
	// Funktionen zum ffnen/Schlieen der Ini-Datei
	void close();
	bool open(char typ);

	// Hilfsfunktionen zum Suchen von Schlsseln und Werten
	bool suche_kay(char* kayname);
	bool suche_wert(char* wertname);	// sucht im Aktuellen Schlssel

	// Hilfsfunktionen zum schreiben/auslesen der daten aus einer *.ini
	void lese_ini();
	void schreibe_ini();

	// Variablen
	FILE* datei;
	char filename[INI_LEN_FILENAME];
	strKay* first_kay;
	strKay* a_kay;		// aktueller Schlssel
	strWert* a_wert;	// aktueller Wert
};

#endif 
