#include <stdio.h>
#include <sdl.h>

#include "AntX.h"
#include "IniFile.h"

/*
#ifdef _WIN32
#undef main
#endif
*/

#define SCREEN_BREITE	800
#define SCREEN_HOEHE	600
#define FELD_BREITE		400
#define FELD_HOEHE		300
#define SCHWEIFLAENGE	20


int main(int argc, char **argv)
{
	if (SDL_Init(SDL_INIT_VIDEO)<0)		// Initialiserung von SDL
	{
		fprintf(stderr,"SDL konnte nicht initialisiert werden: %s\n",SDL_GetError());
		return 1;
	}

	// Titel und Icon setzten
	SDL_WM_SetCaption("AntX","AntX");

	// Game initiierne und starten
	CAntX *game=0;
	CIniFile ini("AntX.ini");
	
	if(ini.ready)
	{
		short sbreite=ini.get_wert_i("AntX","screen_breite");
		short shoehe= ini.get_wert_i("AntX","screen_hoehe");
		short fbreite=ini.get_wert_i("AntX","feld_breite");
		short fhoehe= ini.get_wert_i("AntX","feld_hoehe");
		short schwfl= ini.get_wert_i("AntX","schweifl_gegner");
		
		game = new CAntX(sbreite,shoehe,fbreite,fhoehe,schwfl);
	}
	else
	{
		game = new CAntX(SCREEN_BREITE,SCREEN_HOEHE,FELD_BREITE,FELD_HOEHE,SCHWEIFLAENGE);
	}

	// Programmlogik (Eventbehandlung)
	bool running = true;
	while (running)
	{
		SDL_Event event;
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
			case SDL_KEYDOWN:
				if (event.key.keysym.sym==SDLK_ESCAPE)
					running=false;
				else
					game->press(event.key.keysym.sym);
				break;

			case SDL_QUIT:
				running = false;
				break;
			}
		}
		game->tick();
	}

	delete game;

	return 0;
}
